You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

103 lines
3.9 KiB

3 years ago
  1. #!/usr/bin/env zsh
  2. # -------------------------------------------------------------------------------------------------
  3. # Copyright (c) 2010-2015 zsh-syntax-highlighting contributors
  4. # All rights reserved.
  5. #
  6. # Redistribution and use in source and binary forms, with or without modification, are permitted
  7. # provided that the following conditions are met:
  8. #
  9. # * Redistributions of source code must retain the above copyright notice, this list of conditions
  10. # and the following disclaimer.
  11. # * Redistributions in binary form must reproduce the above copyright notice, this list of
  12. # conditions and the following disclaimer in the documentation and/or other materials provided
  13. # with the distribution.
  14. # * Neither the name of the zsh-syntax-highlighting contributors nor the names of its contributors
  15. # may be used to endorse or promote products derived from this software without specific prior
  16. # written permission.
  17. #
  18. # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
  19. # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
  20. # FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
  21. # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  22. # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  23. # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
  24. # IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
  25. # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  26. # -------------------------------------------------------------------------------------------------
  27. # -*- mode: zsh; sh-indentation: 2; indent-tabs-mode: nil; sh-basic-offset: 2; -*-
  28. # vim: ft=zsh sw=2 ts=2 et
  29. # -------------------------------------------------------------------------------------------------
  30. # Required for add-zle-hook-widget.
  31. zmodload zsh/zle
  32. # Check an highlighter was given as argument.
  33. [[ -n "$1" ]] || {
  34. echo >&2 "Bail out! You must provide the name of a valid highlighter as argument."
  35. exit 2
  36. }
  37. # Check the highlighter is valid.
  38. [[ -f ${0:h:h}/highlighters/$1/$1-highlighter.zsh ]] || {
  39. echo >&2 "Bail out! Could not find highlighter ${(qq)1}."
  40. exit 2
  41. }
  42. # Check the highlighter has test data.
  43. [[ -d ${0:h:h}/highlighters/$1/test-data ]] || {
  44. echo >&2 "Bail out! Highlighter ${(qq)1} has no test data."
  45. exit 2
  46. }
  47. # Load the main script.
  48. typeset -a region_highlight
  49. . ${0:h:h}/zsh-syntax-highlighting.zsh
  50. # Activate the highlighter.
  51. ZSH_HIGHLIGHT_HIGHLIGHTERS=($1)
  52. # Runs a highlighting test
  53. # $1: data file
  54. run_test_internal() {
  55. local -a highlight_zone
  56. local tests_tempdir="$1"; shift
  57. local srcdir="$PWD"
  58. builtin cd -q -- "$tests_tempdir" || { echo >&2 "Bail out! cd failed: $?"; return 1 }
  59. # Load the data and prepare checking it.
  60. PREBUFFER= BUFFER= ;
  61. . "$srcdir"/"$1"
  62. # Check the data declares $PREBUFFER or $BUFFER.
  63. [[ -z $PREBUFFER && -z $BUFFER ]] && { echo >&2 "Bail out! Either 'PREBUFFER' or 'BUFFER' must be declared and non-blank"; return 1; }
  64. # Set $? for _zsh_highlight
  65. true && _zsh_highlight
  66. }
  67. run_test() {
  68. # Do not combine the declaration and initialization: «local x="$(false)"» does not set $?.
  69. local __tests_tempdir
  70. __tests_tempdir="$(mktemp -d)" && [[ -d $__tests_tempdir ]] || {
  71. echo >&2 "Bail out! mktemp failed"; return 1
  72. }
  73. typeset -r __tests_tempdir # don't allow tests to override the variable that we will 'rm -rf' later on
  74. {
  75. (run_test_internal "$__tests_tempdir" "$@")
  76. } always {
  77. rm -rf -- "$__tests_tempdir"
  78. }
  79. }
  80. # Process each test data file in test data directory.
  81. local data_file
  82. TIMEFMT="%*Es"
  83. { time (for data_file in ${0:h:h}/highlighters/$1/test-data/*.zsh; do
  84. run_test "$data_file"
  85. (( $pipestatus[1] )) && exit 2
  86. done) } 2>&1 || exit $?
  87. exit 0